"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
function Interceptor(parameters) {
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters))
        throw new Error("Can not register an interceptor without an instance of IInterceptor.");
    return function (constructor) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(constructor))
            throw new Error("Missing interceptor constructor.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.name))
            parameters.name = paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(constructor);
        constructor[exports.interceptorInfoKey] = parameters;
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.module)) {
            parameters.module.registerInterceptor(constructor);
        }
    };
}
exports.Interceptor = Interceptor;
exports.interceptorInfoKey = "$interceptorInfo";
