Paradigm UI Shared
---

This library adapts angularjs to typescript, using well defined objects, decorators and other typescript functionalities
to work in a ordered manner.

We first started this library to circumvent and later fix or resolve some of the gray areas in angular. Lots of programmers now days come from the web world, and they are already accustomed to dynamic languages and their advantages, but sometimes ignoring the benefits of using strong typing,  and using classical inheritance vs prototypical inheritance. This library is oriented to people who want to have a more classical approach to application development, but still enjoy new technologies like angular, using tools like gulp to compile, run tests and do tons of other stuff.

Regarding angular and its idea of MVW, we are not happy with the W. "Whatever" is not a software philosophy, but a lack of design, a lack of minimal structure, which in the end produces lots of programmer not knowing what is the best place to develop some specific functionality. We aim to fix that while still giving power to the user.


Change log
---
Version `1.0.9`
- Now templateUrl in decorators will do a `require('url')` and the framework will internally use the
  template text instead of the url. This allow webpack and other bundling tools to cache template files.
- Improved Directive decorators.

Version `1.0.8`
- Changed directive class names to end with the word Directive.
- Added tempalte field to controller decorator.

Version `1.0.7`
- Added importHelpers flag to typescript.
- Added tslib as dependency.

Version `1.0.6`
- Fixed an error with typescript compiler adding invalid references to
  angular-mocks in d.ts files even when not referenced.

Version `1.0.5`
- Fixed wrong parameter type in controller when registering messages.
- Added missing exports to the index file.
- Renamed Alert to AlertDirective to differenciate from Alert object.

Version `1.0.4`
- Changed HttpServiceBase to mimic the http service in angular.

Version `1.0.3`
- Changed dialog name conventions.
- Added translate method to controllers and components.

Version `1.0.2`
- Added Message decorator to ease the work with the message bus.
- Improved message bus with new methods and improved parameters.
- Added better support for message bus inside controllers and components.
- Separated base controller in two classes to allow users to choose not to use our base clases.
- Fixed licencing on files.
- Added licencing file.

Version `1.0.1`
- Added support for components.

Version `1.0.0`
- Uploaded first version of the library.