"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
var base_service_1 = require("./base.service");
var service_1 = require("../decorators/service");
var angular_service_1 = require("./angular.service");
var framework_service_1 = require("./framework.service");
var ExceptionService = /** @class */ (function (_super) {
    tslib_1.__extends(ExceptionService, _super);
    function ExceptionService(alertService, logger) {
        var _this = _super.call(this) || this;
        _this.alertService = alertService;
        _this.logger = logger;
        return _this;
    }
    ExceptionService_1 = ExceptionService;
    ExceptionService.prototype.processException = function (exception, cause) {
        this.alertService.addError(exception.message);
        this.logger.writeError("Error: " + exception + "\n\nCause:" + cause);
    };
    ExceptionService.factory = function (alertService, logger) {
        return function (exception, cause) { return new ExceptionService_1(alertService, logger).processException(exception, cause); };
    };
    ExceptionService = ExceptionService_1 = tslib_1.__decorate([
        service_1.Service({
            name: angular_service_1.AngularServices.exceptionHandler,
            factory: ExceptionService_1.factory,
            dependencies: [framework_service_1.FrameworkServices.alertService, framework_service_1.FrameworkServices.loggingService]
        })
    ], ExceptionService);
    return ExceptionService;
    var ExceptionService_1;
}(base_service_1.ServiceBase));
exports.ExceptionService = ExceptionService;
