/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { IMessageBus, RegistrationToken } from "./message-bus.service.interface";
export declare class MessageBus extends ServiceBase implements IMessageBus {
    private handlers;
    constructor();
    count(): number;
    isRegistered<T>(messageType: new (...args) => T): boolean;
    handlerCount<T>(messageType: new (...args) => T): number;
    register<T>(messageType: {
        new (...args): T;
    }, handler: (x: T) => void): RegistrationToken;
    unregister(token: RegistrationToken): void;
    send<T>(message: T, token?: RegistrationToken): boolean;
    static factory(): MessageBus;
}
